#!/usr/bin/env perl
#
#  Copyright 1996-2011 Jim Pirzyk / pirzyk.org
#  All rights reserved.
#
#  10.t - read_config() testing
#

use Test;
use strict;
use warnings "all";

use Security::util::read_config;

our (%opts, %config);
$opts{'C'} = 't/security.cf';
#$opts{'d'} = 1;

my @modules;
push @modules, glob ( 'lib/Security/*.pm' );
map {
	s,lib/Security/,,;
	s/\.pm$//;
} @modules;

plan tests => 4 + scalar @modules;

# generate the security.cf file to test against
`perl -I blib/lib sbin/generate_config.pl -m localhost -I -P . -R . -M /blib/lib > $opts{'C'} 2> /dev/null`;
ok ($?, 0, "Error running generate_config.pl");

my $count = `grep \\^load $opts{'C'}|wc -w`;
&read_config('load');
ok ( scalar @{$config{'load'}}, ($count - 1), "Not the correct number of modules in the load list");
foreach my $m ( @modules ) {
	ok ( grep (/^\Q${m}\E$/, @{$config{'load'}}), 1, "Module $m not found in load list");
}

&read_config('mailhost');
ok ( scalar @{$config{'mailhost'}}, 1, "not correct unber of entries mailhost config");
ok ( $config{'mailhost'}[0], 'localhost', "mailhost config variable not correct");

unlink($opts{'C'});

exit 0;
